package kr.co.vividnext.sodalive.admin.audition.role

import kr.co.vividnext.sodalive.common.SodaException

data class CreateAuditionRoleRequest(
    val auditionId: Long,
    val name: String,
    val information: String,
    val auditionScriptUrl: String
) {
    init {
        if (auditionId < 0) {
            throw SodaException("캐릭터가 등록될 오디션을 선택하세요")
        }

        if (name.isBlank() || name.length < 2) {
            throw SodaException("캐릭터명을 입력하세요")
        }

        if (auditionScriptUrl.isBlank() || auditionScriptUrl.length < 10) {
            throw SodaException("오디션 대본 URL을 입력하세요")
        }

        if (information.isBlank() || information.length < 10) {
            throw SodaException("오디션 캐릭터 정보는 최소 10글자 입니다")
        }
    }
}
