package kr.co.vividnext.sodalive.admin.content.tab

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.content.main.tab.AudioContentMainTab
import kr.co.vividnext.sodalive.content.main.tab.GetContentMainTabItem
import kr.co.vividnext.sodalive.content.main.tab.QAudioContentMainTab.audioContentMainTab
import kr.co.vividnext.sodalive.content.main.tab.QGetContentMainTabItem
import org.springframework.data.jpa.repository.JpaRepository

interface AdminContentMainTabRepository : JpaRepository<AudioContentMainTab, Long>, AdminContentMainTabQueryRepository

interface AdminContentMainTabQueryRepository {
    fun findAllByActiveIsTrue(): List<GetContentMainTabItem>
}

class AdminContentMainTabQueryRepositoryImpl(
    private val queryFactory: JPAQueryFactory
) : AdminContentMainTabQueryRepository {
    override fun findAllByActiveIsTrue(): List<GetContentMainTabItem> {
        return queryFactory
            .select(
                QGetContentMainTabItem(
                    audioContentMainTab.id,
                    audioContentMainTab.title
                )
            )
            .from(audioContentMainTab)
            .where(audioContentMainTab.isActive.isTrue)
            .fetch()
    }
}
