package kr.co.vividnext.sodalive.admin.statistics.ad

import kr.co.vividnext.sodalive.extensions.convertLocalDateTime
import org.springframework.stereotype.Service

@Service
class AdminAdStatisticsService(
    private val repository: AdminAdStatisticsRepository
) {
    fun getStatistics(
        startDateStr: String,
        endDateStr: String,
        offset: Long,
        limit: Long
    ): GetAdminAdStatisticsResponse {
        val startDate = startDateStr.convertLocalDateTime()
        val endDate = endDateStr.convertLocalDateTime(hour = 23, minute = 59, second = 59)

        val totalCount = repository.getAdStatisticsDataTotalCount(startDate, endDate)
        val items = repository.getAdStatisticsDataList(startDate, endDate, offset, limit)

        return GetAdminAdStatisticsResponse(
            totalCount = totalCount,
            items = items
        )
    }
}
