package kr.co.vividnext.sodalive.audition.role

import kr.co.vividnext.sodalive.audition.applicant.AuditionApplicantRepository
import kr.co.vividnext.sodalive.common.SodaException
import org.springframework.stereotype.Service

@Service
class AuditionRoleService(
    private val repository: AuditionRoleRepository,
    private val applicantRepository: AuditionApplicantRepository
) {
    fun getAuditionRoleDetail(auditionRoleId: Long, memberId: Long): GetAuditionRoleDetailResponse {
        val roleDetailData = repository.getAuditionRoleDetail(auditionRoleId = auditionRoleId)
            ?: throw SodaException("잘못된 요청입니다.\n다시 시도해 주세요.")

        val isAlreadyApplicant = applicantRepository.isAlreadyApplicant(
            auditionRoleId = auditionRoleId,
            memberId = memberId
        )

        return roleDetailData.toDetailResponse(isAlreadyApplicant = isAlreadyApplicant)
    }
}
