package kr.co.vividnext.sodalive.can.charge.event

import org.springframework.scheduling.annotation.Async
import org.springframework.stereotype.Component
import org.springframework.transaction.event.TransactionalEventListener

class ChargeSpringEvent(
    val chargeId: Long,
    val memberId: Long
)

@Component
class ChargeSpringEventListener(
    private val chargeEventService: ChargeEventService
) {
    @Async
    @TransactionalEventListener
    fun applyChargeEvent(event: ChargeSpringEvent) {
        chargeEventService.applyChargeEvent(event.chargeId, event.memberId)
    }
}
