package kr.co.vividnext.sodalive.can.use

import kr.co.vividnext.sodalive.can.payment.PaymentGateway
import kr.co.vividnext.sodalive.common.BaseEntity
import javax.persistence.CascadeType
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne

@Entity
data class UseCanCalculate(
    val can: Int,

    @Column(nullable = false)
    @Enumerated(value = EnumType.STRING)
    val paymentGateway: PaymentGateway,

    @Column(nullable = false)
    @Enumerated(value = EnumType.STRING)
    var status: UseCanCalculateStatus
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY, cascade = [CascadeType.ALL])
    @JoinColumn(name = "use_can_id", nullable = false)
    var useCan: UseCan? = null
        set(value) {
            value?.useCanCalculates?.add(this)
            field = value
        }

    var recipientCreatorId: Long? = null
}

enum class UseCanCalculateStatus {
    RECEIVED, CALCULATE_COMPLETE, REFUND
}
