package kr.co.vividnext.sodalive.common

data class ApiResponse<T>(
    val success: Boolean,
    val message: String? = null,
    val data: T? = null,
    val errorProperty: String? = null
) {
    companion object {
        fun <T> ok(data: T? = null, message: String? = null) = ApiResponse(
            success = true,
            message = message,
            data = data
        )

        fun error(message: String? = null, errorProperty: String? = null) = ApiResponse<Any>(
            success = false,
            message = message,
            errorProperty = errorProperty
        )
    }
}
