package kr.co.vividnext.sodalive.marketing

import java.time.LocalDateTime
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.GeneratedValue
import javax.persistence.GenerationType
import javax.persistence.Id
import javax.persistence.PreUpdate

@Entity
data class AdTrackingHistory(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long? = null,
    val mediaGroup: String,
    val pid: String,
    val pidName: String,
    @Enumerated(value = EnumType.STRING)
    val type: AdTrackingHistoryType,
    val price: Double = 0.toDouble(),
    val locale: String? = null,
    val memberId: Long,
    val createdAt: LocalDateTime = LocalDateTime.now(),
    var updatedAt: LocalDateTime = LocalDateTime.now()
) {
    @PreUpdate
    fun preUpdate() {
        updatedAt = LocalDateTime.now()
    }
}

enum class AdTrackingHistoryType {
    // 앱 실행
    APP_LAUNCH,

    // 회원가입
    SIGNUP,

    // 첫결제
    FIRST_PAYMENT,

    // 재결제
    REPEAT_PAYMENT,

    // 자동로그인
    LOGIN
}
