package kr.co.vividnext.sodalive.search

import com.querydsl.core.annotations.QueryProjection

data class SearchUnifiedResponse(
    val creatorList: List<SearchResponseItem>,
    val contentList: List<SearchResponseItem>,
    val seriesList: List<SearchResponseItem>
)

data class SearchResponse(
    val totalCount: Int,
    val items: List<SearchResponseItem>
)

data class SearchResponseItem @QueryProjection constructor(
    val id: Long,
    val imageUrl: String,
    val title: String,
    val nickname: String
) {
    var type: SearchResponseType = SearchResponseType.CREATOR
}

enum class SearchResponseType {
    CREATOR, CONTENT, SERIES
}
